## osm2pgsql 1.4.1+ds

=== CMakeLists.txt ===
set(PACKAGE osm2pgsql)
set(PACKAGE_NAME osm2pgsql)
set(PACKAGE_VERSION 1.4.1)

cmake_minimum_required(VERSION 2.8.12)

project(osm2pgsql)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

if (WIN32)
    set(DEFAULT_STYLE "default.style" CACHE STRING "Default style used unless one is given on the command line")
else()
    set(DEFAULT_STYLE "${CMAKE_INSTALL_PREFIX}/share/osm2pgsql/default.style" CACHE STRING "Default style used unless one is given on the command line")
endif()

option(BUILD_TESTS    "Build test suite" OFF)
option(BUILD_COVERAGE "Build with coverage" OFF)
option(WITH_LUA       "Build with Lua support" ON)
option(WITH_LUAJIT    "Build with LuaJIT support" OFF)

if (PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
    message(FATAL_ERROR "In-source builds are not allowed, please use a separate build directory like `mkdir build && cd build && cmake ..`")
endif()

message(STATUS "Building osm2pgsql ${PACKAGE_VERSION}")

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

if (NOT "${CMAKE_CXX_STANDARD}")
    set(CMAKE_CXX_STANDARD 11)
endif()
message(STATUS "Building in C++${CMAKE_CXX_STANDARD} mode")
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if (MSVC)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -DNOMINMAX -wd4996)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /ignore:4099 /STACK:30000000")
else()
    add_definitions(-Wall)
    if (CMAKE_VERSION VERSION_LESS 3.1)
        add_definitions(-std=c++11)
    endif()
endif()

option(EXTERNAL_LIBOSMIUM "Do not use the bundled libosmium" OFF)
option(EXTERNAL_PROTOZERO "Do not use the bundled protozero" OFF)
option(EXTERNAL_FMT       "Do not use the bundled fmt"       OFF)

set(USE_PROJ_LIB "auto" CACHE STRING "Which version of PROJ API to use: ('4', '6', 'off', or 'auto')")

if (NOT WIN32 AND NOT APPLE)
    # No need for this path, just a workaround to make cmake work on all systems.
    # Without this we need the PostgreSQL server libraries installed.
    # https://stackoverflow.com/questions/13920383/findpostgresql-cmake-wont-work-on-ubuntu
    set(PostgreSQL_TYPE_INCLUDE_DIR /usr/include)
endif()

set(MINIMUM_POSTGRESQL_SERVER_VERSION "9.3")
set(MINIMUM_POSTGRESQL_SERVER_VERSION_NUM "90300")

set(PostgreSQL_ADDITIONAL_VERSIONS "13" "12" "11" "10" "9.6" "9.5" "9.4" "9.3")

#############################################################
# Version
#############################################################

find_package(Git)

if (GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tags --dirty=-changed
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                    OUTPUT_VARIABLE VERSION_FROM_GIT
                    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if (VERSION_FROM_GIT)
        set(VERSION_FROM_GIT " (${VERSION_FROM_GIT})")
    endif()
endif()

configure_file(
    ${PROJECT_SOURCE_DIR}/src/version.cpp.in
    ${PROJECT_BINARY_DIR}/src/version.cpp
)

#############################################################
# Coverage
#############################################################

if (BUILD_COVERAGE)
    if (NOT BUILD_TESTS)
        message(WARNING "Coverage build enabled, but tests not enabled!")
    endif()

    if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        string(REGEX REPLACE "^([0-9]+).*$" "llvm-cov-\\1"
               gcov_ ${CMAKE_CXX_COMPILER_VERSION})
        set(gcov_param_ " gcov")
    else()
        set(gcov_ "gcov")
        set(gcov_param_ "")
    endif()

    message(STATUS "Looking for coverage tool: ${gcov_}")

    find_program(GCOV ${gcov_} DOC "Coverage tool")

    if (GCOV STREQUAL "GCOV-NOTFOUND")
        message(STATUS "  coverage tool not found - coverage disabled")
    else()
        message(STATUS "  found")

        message(STATUS "Looking von gcovr")
        find_program(GCOVR "gcovr" DOC "Coverage report tool")
        if (GCOVR STREQUAL "GCOVR-NOTFOUND")
            message(WARNING "  gcovr not found - coverage will not work")
        else()
            message(STATUS "  found")
        endif()

        add_definitions(-g -O0 -fno-inline-functions -fno-inline --coverage)

        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage"
            CACHE
            STRING "Flags used by the linker during all build types."
            FORCE)

        set(coverage_report_dir "${CMAKE_BINARY_DIR}/coverage")
        file(MAKE_DIRECTORY ${coverage_report_dir})
        add_custom_target(coverage
            ${GCOVR}
            ${CMAKE_BINARY_DIR}
            --root=${CMAKE_SOURCE_DIR}
            --html-details
            --html-title "osm2pgsql coverage report"
            #--verbose
            #--keep
            --delete
            '--exclude=.*contrib.*'
            --sort-percentage
            --gcov-executable=${GCOV}${gcov_param_}
            --output=${coverage_report_dir}/index.html)
    endif()
endif()

#############################################################
# Detect available headers and set global compiler options
#############################################################

include(CheckIncludeFiles)

add_definitions(-DDEFAULT_STYLE=\"${DEFAULT_STYLE}\")

CHECK_INCLUDE_FILES(termios.h HAVE_TERMIOS_H)
CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)

#############################################################
# Find necessary libraries
#############################################################

if (NOT EXTERNAL_LIBOSMIUM)
    set(OSMIUM_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/libosmium/include")
endif()

if (NOT EXTERNAL_PROTOZERO)
    set(PROTOZERO_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/protozero/include")
endif()

if (NOT EXTERNAL_FMT)
    set(FMT_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/fmt/include")
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR})

find_package(Osmium 2.15.6 REQUIRED COMPONENTS io)
include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS} ${PROTOZERO_INCLUDE_DIR} ${FMT_INCLUDE_DIR})

if (WITH_LUA)
    if (WITH_LUAJIT)
        find_package(LuaJIT REQUIRED)
        include_directories(SYSTEM ${LUAJIT_INCLUDE_DIR})
        set(HAVE_LUAJIT 1)
    else()
        find_package(Lua REQUIRED)
        include_directories(SYSTEM ${LUA_INCLUDE_DIR})
    endif()
    set(HAVE_LUA 1)
    find_program(LUA_EXE lua)
endif()

find_package(Boost 1.50 REQUIRED COMPONENTS system filesystem)
include_directories(SYSTEM ${Boost_INCLUDE_DIR})

find_package(PostgreSQL REQUIRED)
include_directories(SYSTEM ${PostgreSQL_INCLUDE_DIRS})

find_package(Threads)

############### Libraries are found now ########################

set(LIBS ${Boost_LIBRARIES} ${PostgreSQL_LIBRARY} ${OSMIUM_LIBRARIES})

if (USE_PROJ_LIB STREQUAL "off")
    message(STATUS "Proj library disabled (because USE_PROJ_LIB is set to 'off').")
else()
    find_path(PROJ4_INCLUDE_DIR proj_api.h)
    if (PROJ4_INCLUDE_DIR AND NOT USE_PROJ_LIB STREQUAL "6")
        message(STATUS "Found proj_api.h")
        find_library(PROJ_LIBRARY NAMES proj)
        message(STATUS "Found Proj [API 4] ${PROJ_LIBRARY}")
        set(HAVE_GENERIC_PROJ 1)
        set(HAVE_PROJ4 1)
        list(APPEND LIBS ${PROJ_LIBRARY})
        include_directories(SYSTEM ${PROJ4_INCLUDE_DIR})
    elseif (NOT USE_PROJ_LIB STREQUAL "4")
        find_path(PROJ6_INCLUDE_DIR proj.h)
        find_library(PROJ_LIBRARY NAMES proj)
        if (PROJ_LIBRARY)
            message(STATUS "Found Proj [API 6] ${PROJ_LIBRARY}")
            set(HAVE_GENERIC_PROJ 1)
            set(HAVE_PROJ6 1)
            list(APPEND LIBS ${PROJ_LIBRARY})
            include_directories(SYSTEM ${PROJ6_INCLUDE_DIR})
        else()
            message(STATUS "Proj library not found.")
            message(STATUS "    Only Mercartor and WGS84 projections will be available.")
        endif()
    endif()
endif()

if (USE_PROJ_LIB STREQUAL "4" AND NOT HAVE_PROJ4)
    message(FATAL_ERROR "USE_PROJ_LIB was set to '4', but PROJ version 4 API not found")
endif()

if (USE_PROJ_LIB STREQUAL "6" AND NOT HAVE_PROJ6)
    message(FATAL_ERROR "USE_PROJ_LIB was set to '6', but PROJ version 6 API not found")
endif()

if (LUAJIT_FOUND)
    list(APPEND LIBS ${LUAJIT_LIBRARIES})
elseif (LUA_FOUND)
    list(APPEND LIBS ${LUA_LIBRARIES})
endif()

if (WIN32)
    list(APPEND LIBS ws2_32)
    if (MSVC)
        find_path(GETOPT_INCLUDE_DIR getopt.h)
        find_library(GETOPT_LIBRARY NAMES wingetopt getopt)
        if (GETOPT_INCLUDE_DIR AND GETOPT_LIBRARY)
            include_directories(SYSTEM ${GETOPT_INCLUDE_DIR})
            list(APPEND LIBS ${GETOPT_LIBRARY})
        else()
            message(FATAL_ERROR "Can not find getopt library for Windows. Please get it from https://github.com/alex85k/wingetopt or alternative source.")
        endif()
    endif()
endif()

message(STATUS "Libraries used to build: ${LIBS}")

#############################################################
# Build the library and executable file
#############################################################

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)

if (NOT HAVE_UNISTD_H AND NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/unistd.h)
   file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/unistd.h "// empty header\n")
endif()

add_subdirectory(src)

add_executable(osm2pgsql src/osm2pgsql.cpp)
target_link_libraries(osm2pgsql osm2pgsql_lib ${LIBS})

#############################################################
# Optional "clang-tidy" target
#############################################################

message(STATUS "Looking for clang-tidy")
find_program(CLANG_TIDY
             NAMES clang-tidy clang-tidy-10 clang-tidy-9 clang-tidy-8 clang-tidy-7)

if (CLANG_TIDY)
    message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")

    file(GLOB CT_CHECK_FILES src/*.cpp tests/*cpp)

    add_custom_target(clang-tidy
        ${CLANG_TIDY}
        -p ${CMAKE_BINARY_DIR}
        ${CT_CHECK_FILES}
    )
else()
    message(STATUS "Looking for clang-tidy - not found")
    message(STATUS "  Build target 'clang-tidy' will not be available.")
endif()

#############################################################
# Build tests
#############################################################

if (BUILD_TESTS)
    enable_testing()
    if (NOT TESTING_TIMEOUT)
        set(TESTING_TIMEOUT 1200)
    endif()
    add_subdirectory(tests)
else()
    message(STATUS "Tests disabled. Set BUILD_TESTS=ON to enable tests.")
endif()

#############################################################
# Man page
#############################################################

add_subdirectory(docs)

#############################################################
# Install
#############################################################

install(TARGETS osm2pgsql DESTINATION bin)
install(FILES default.style empty.style DESTINATION share/osm2pgsql)

=== docs/CMakeLists.txt ===

message(STATUS "Looking for pandoc")
find_program(PANDOC pandoc)

if(PANDOC)
    message(STATUS "Looking for pandoc - found")
    message(STATUS "  Manual page can be built using 'man' target")
    set(PANDOC_MAN_OPTIONS
        -s
        -t man
        --template ${CMAKE_CURRENT_SOURCE_DIR}/manpage.template
        --variable "version=${PACKAGE_VERSION}"
        --variable "title=OSM2PGSQL"
        --variable "section=1"
    )

    add_custom_command(OUTPUT osm2pgsql.1
        COMMAND ${PANDOC} ${PANDOC_MAN_OPTIONS} -o osm2pgsql.1
            ${CMAKE_CURRENT_SOURCE_DIR}/osm2pgsql.md
        DEPENDS osm2pgsql.md manpage.template
        COMMENT "Building manpage osm2pgsql.1"
        VERBATIM)

    add_custom_target(man DEPENDS osm2pgsql.1 VERBATIM)
else()
    message(STATUS "Looking for pandoc - not found")
    message(STATUS "  Manual page can not be built")
endif()

install(FILES osm2pgsql.1 DESTINATION share/man/man1)

=== src/CMakeLists.txt ===

set(osm2pgsql_lib_SOURCES
  db-check.cpp
  db-copy.cpp
  dependency-manager.cpp
  expire-tiles.cpp
  gazetteer-style.cpp
  geom.cpp
  geometry-processor.cpp
  input.cpp
  logging.cpp
  middle.cpp
  middle-pgsql.cpp
  middle-ram.cpp
  node-persistent-cache.cpp
  node-ram-cache.cpp
  options.cpp
  osmdata.cpp
  osmium-builder.cpp
  output-gazetteer.cpp
  output-multi.cpp
  output-null.cpp
  output-pgsql.cpp
  output.cpp
  pgsql.cpp
  pgsql-helper.cpp
  processor-line.cpp
  processor-point.cpp
  processor-polygon.cpp
  progress-display.cpp
  reprojection.cpp
  sprompt.cpp
  table.cpp
  taginfo.cpp
  tagtransform-c.cpp
  tagtransform.cpp
  util.cpp
  wildcmp.cpp
)

if (LUA_FOUND OR LUAJIT_FOUND)
    set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
                 "${CMAKE_CURRENT_SOURCE_DIR}/init.lua")
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/init.lua" LUA_INIT_CODE)
    configure_file(lua-init.cpp.in lua-init.cpp @ONLY)
    list(APPEND osm2pgsql_lib_SOURCES
        flex-table.cpp
        flex-table-column.cpp
        geom-transform.cpp
        lua-utils.cpp
        output-flex.cpp
        tagtransform-lua.cpp
        ${CMAKE_CURRENT_BINARY_DIR}/lua-init.cpp)
endif()

list(APPEND osm2pgsql_lib_SOURCES ${PROJECT_BINARY_DIR}/src/version.cpp)

if (HAVE_PROJ4)
    list(APPEND osm2pgsql_lib_SOURCES reprojection-generic-proj4.cpp)
    if (NOT MSVC)
        set_source_files_properties(reprojection-generic-proj4.cpp
            PROPERTIES COMPILE_FLAGS -Wno-deprecated-declarations)
    endif()
elseif(HAVE_PROJ6)
    list(APPEND osm2pgsql_lib_SOURCES reprojection-generic-proj6.cpp)
else()
    list(APPEND osm2pgsql_lib_SOURCES reprojection-generic-none.cpp)
endif()

add_library(osm2pgsql_lib STATIC ${osm2pgsql_lib_SOURCES})
set_target_properties(osm2pgsql_lib PROPERTIES OUTPUT_NAME osm2pgsql)
target_link_libraries(osm2pgsql_lib ${LIBS})

=== tests/CMakeLists.txt ===
# Add a new test
#
# set_test(name [LABELS labels])
#
# name - Name of test (source file without suffix)
# labels - optional labels for the test
function(set_test test_name)
    cmake_parse_arguments(test_param "" "" "LABELS" ${ARGN})

    add_executable(${test_name} ${test_name}.cpp)
    target_link_libraries(${test_name} osm2pgsql_lib catch_main_lib)
    add_test(NAME ${test_name} COMMAND ${test_name})

    set_tests_properties(${test_name} PROPERTIES TIMEOUT ${TESTING_TIMEOUT}
                                                 ENVIRONMENT SRCPATH=${CMAKE_CURRENT_SOURCE_DIR})

    if (DEFINED test_param_LABELS)
        list(FIND test_param_LABELS Tablespace test_num_labels)
        if (${test_num_labels} EQUAL -1)
            list(APPEND test_param_LABELS "NoTablespace")
        else()
            set_tests_properties(${test_name}
                                 PROPERTIES FIXTURES_REQUIRED Tablespace)
        endif()

        set_tests_properties(${test_name} PROPERTIES LABELS "${test_param_LABELS}")
    else()
        set_tests_properties(${test_name} PROPERTIES LABELS NoTablespace)
    endif()

    message(STATUS "Added test: ${test_name}...")
endfunction()

include_directories(SYSTEM "${CMAKE_CURRENT_SOURCE_DIR}/../contrib/catch2/include")

add_definitions(-DTESTDATA_DIR=\"${osm2pgsql_SOURCE_DIR}/tests/data/\")
add_definitions(-DOSM2PGSQLDATA_DIR=\"${osm2pgsql_SOURCE_DIR}/\")

add_library(catch_main_lib STATIC catch-main.cpp)

set_test(test-check-input LABELS NoDB)
set_test(test-db-copy-thread)
set_test(test-db-copy-mgr)
set_test(test-domain-matcher LABELS NoDB)
set_test(test-expire-tiles LABELS NoDB)
set_test(test-geom LABELS NoDB)
set_test(test-middle)
set_test(test-options-database LABELS NoDB)
set_test(test-options-parse LABELS NoDB)
set_test(test-options-projection)
set_test(test-output-gazetteer)
set_test(test-output-multi-line)
set_test(test-output-multi-point)
set_test(test-output-multi-point-multi-table)
set_test(test-output-multi-polygon)
set_test(test-output-pgsql)
set_test(test-output-pgsql-area)
set_test(test-output-pgsql-hstore-match-only)
set_test(test-output-pgsql-int4)
set_test(test-output-pgsql-schema)
set_test(test-output-pgsql-tablespace LABELS Tablespace)
set_test(test-output-pgsql-validgeom)
set_test(test-output-pgsql-z_order)
set_test(test-parse-osmium LABELS NoDB)
set_test(test-persistent-cache LABELS NoDB)
set_test(test-pgsql)
set_test(test-ram-cache LABELS NoDB)
set_test(test-reprojection LABELS NoDB)
set_test(test-taginfo LABELS NoDB)
set_test(test-util LABELS NoDB)
set_test(test-wildcard-match LABELS NoDB)

# these tests require LUA support
if (HAVE_LUA)
    set_test(test-output-multi-line-storage)
    set_test(test-output-multi-poly-trivial)
    set_test(test-output-multi-tags)
    set_test(test-output-flex)
    set_test(test-output-flex-area)
    set_test(test-output-flex-attr)
    set_test(test-output-flex-bbox)
    set_test(test-output-flex-invalid-geom)
    set_test(test-output-flex-line)
    set_test(test-output-flex-lua-fail)
    set_test(test-output-flex-multigeom)
    set_test(test-output-flex-multi-input)
    set_test(test-output-flex-nodes)
    set_test(test-output-flex-nogeom)
    set_test(test-output-flex-uni)
    set_test(test-output-flex-relations)
    set_test(test-output-flex-relation-changes)
    set_test(test-output-flex-relation-combinations)
    set_test(test-output-flex-schema)
    set_test(test-output-flex-stage2)
    set_test(test-output-flex-tablespace LABELS Tablespace)
    set_test(test-output-flex-types)
    set_test(test-output-flex-update)
    set_test(test-output-flex-validgeom)
    set_test(test-output-flex-way-add)
    set_test(test-output-flex-way-change)
    set_test(test-output-flex-way-del)
    set_test(test-output-flex-way-relation-add)
    set_test(test-output-flex-way-relation-del)

    set_test(test-output-flex-example-configs)
    set(FLEX_EXAMPLE_CONFIGS "compatible,data-types,generic,geometries,route-relations,simple,unitable")
    # places.lua not tested because it needs dkjson package
    set_tests_properties(test-output-flex-example-configs PROPERTIES ENVIRONMENT "EXAMPLE_FILES=${FLEX_EXAMPLE_CONFIGS}")
endif()


# Fixture for creating test tablespace under a pg_virtualenv
if (NOT WIN32)
    message(STATUS "Added tablespace fixture...")
    add_test(NAME FixtureTablespaceSetup
             COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/fixture-tablespace-setup
             WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
    add_test(NAME FixtureTablespaceCleanup
             COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/fixture-tablespace-cleanup
             WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

    set_tests_properties(FixtureTablespaceSetup PROPERTIES FIXTURES_SETUP Tablespace)
    set_tests_properties(FixtureTablespaceCleanup PROPERTIES FIXTURES_CLEANUP Tablespace)
endif()


find_package(PythonInterp 3)

if (PYTHONINTERP_FOUND)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/regression-test.py.in
                   ${CMAKE_CURRENT_BINARY_DIR}/regression-test.py)

    add_test(NAME regression-test-pbf
             COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/regression-test.py -v)
    set_tests_properties(regression-test-pbf PROPERTIES TIMEOUT ${TESTING_TIMEOUT})
    set_tests_properties(regression-test-pbf
                         PROPERTIES FIXTURES_REQUIRED Tablespace)
    message(STATUS "Added test: regression-test-pbf (needs Python with psycopg2 module)")
else()
    message(WARNING "Can not find python, regression test disabled")
endif()

if (HAVE_LUA)
    if (LUA_EXE)
        message(STATUS "Added test: lua-lib")
        add_test(NAME lua-lib COMMAND ${LUA_EXE} lua/tests.lua
                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
        set_tests_properties(lua-lib PROPERTIES LABELS NoDB)
    else()
        message(WARNING "Can not find Lua interpreter, test 'lua-lib' disabled")
    endif()
endif()

=== debian/changelog ===
osm2pgsql (1.4.1+ds-2) unstable; urgency=medium

  * Update watch file for GitHub URL changes.
  * Add upstream patches:
    - 0001-Bugfix-Disable-expire-in-flex-output-when-not-used.patch
      Important performance fix.
    - 0001-Bug-fix-Remove-schema-name-from-CREATE-INDEX.patch
      Fix CREATE INDEX failure.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 07 Apr 2021 15:59:14 +0200

osm2pgsql (1.4.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update upstream metadata.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 04 Feb 2021 05:23:03 +0100

osm2pgsql (1.4.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Bump watch file version to 4.
  * Update lintian overrides.
  * Bump Standards-Version to 4.5.1, no changes.
  * Update Homepage URL.
  * Use lua5.3 instead of lua5.2.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 07 Dec 2020 13:50:03 +0100

=== debian/control ===
Source: osm2pgsql
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           David Paleino <dapal@debian.org>,
           Andreas Tille <tille@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: utils
Priority: optional
Build-Depends: debhelper (>= 10~),
               cmake,
               libboost-dev,
               libboost-system-dev,
               libboost-filesystem-dev,
               libbz2-dev,
               libexpat1-dev,
               libosmium2-dev (>= 2.15.6),
               libpq-dev,
               libproj-dev,
               zlib1g-dev,
               liblua5.3-dev,
               lua5.3,
               python3,
               python3-psycopg2
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git
Homepage: https://osm2pgsql.org/

Package: osm2pgsql
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: postgis
Description: OpenStreetMap data to PostgreSQL converter
 Convert OSM planet snapshot data to SQL suitable for loading
 into a PostgreSQL database with PostGIS geospatial extensions. This
 database may then be used to render maps with Mapnik or for other
 geospatial analysis.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for osm2pgsql

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Verbose test output
export VERBOSE=1

CFLAGS += $(CPPFLAGS) -DNDEBUG
CXXFLAGS += $(CPPFLAGS) -DNDEBUG

%:
	dh $@ --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- -DEXTERNAL_LIBOSMIUM=ON \
	                     -DEXTERNAL_PROTOZERO=ON

override_dh_auto_test:
	dh_auto_test || echo "Ignoring test failures"

override_dh_install:
	dh_install --list-missing

override_dh_compress:
	# clean up some naive file permissions
	dh_compress -X.php -X.sql -X.js -X.c -X.h

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,\
uversionmangle=s/_/./g;s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/;s/RC/rc/,\
filenamemangle=s/(?:.*?\/)?(?:rel|v|osm2pgsql)?[\-\_]?(\d\S+)\.(tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))/osm2pgsql-$1.$2/,\
repacksuffix=+ds \
https://github.com/openstreetmap/osm2pgsql/releases \
(?:.*?/archive/(?:.*?/)?)?(?:rel|v|osm2pgsql)?[\-\_]?(\d\S+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## osm2pgsql 1.5.1+ds

=== debian/changelog ===
osm2pgsql (1.5.1+ds-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 15 Aug 2021 11:03:42 +0200

osm2pgsql (1.5.1+ds-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 30 Jul 2021 06:31:09 +0200

osm2pgsql (1.5.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Exclude rapidjson sources from repacked upstream tarball.
  * Use external rapidjson.
  * Update copyright file.
  * Require at least libosmium2-dev 2.17.0.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 03 Jun 2021 07:02:20 +0200

osm2pgsql (1.4.2+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update watch file for GitHub URL changes.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 07 Apr 2021 15:33:42 +0200

=== debian/control ===
--- 
+++ 
@@ -13,9 +13,10 @@
                libboost-filesystem-dev,
                libbz2-dev,
                libexpat1-dev,
-               libosmium2-dev (>= 2.15.6),
+               libosmium2-dev (>= 2.17.0),
                libpq-dev,
                libproj-dev,
+               rapidjson-dev,
                zlib1g-dev,
                liblua5.3-dev,
                lua5.3,

=== debian/rules ===
--- 
+++ 
@@ -18,7 +18,8 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DEXTERNAL_LIBOSMIUM=ON \
-	                     -DEXTERNAL_PROTOZERO=ON
+	                     -DEXTERNAL_PROTOZERO=ON \
+	                     -DEXTERNAL_RAPIDJSON=ON
 
 override_dh_auto_test:
 	dh_auto_test || echo "Ignoring test failures"

## osm2pgsql 1.6.0%2Bds

=== debian/control ===
--- 
+++ 
@@ -6,14 +6,15 @@
            Bas Couwenberg <sebastic@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 10~),
+Build-Depends: debhelper-compat (= 12),
                cmake,
+               dh-python,
                libboost-dev,
                libboost-system-dev,
                libboost-filesystem-dev,
                libbz2-dev,
                libexpat1-dev,
-               libosmium2-dev (>= 2.17.0),
+               libosmium2-dev (>= 2.17.3),
                libpq-dev,
                libproj-dev,
                rapidjson-dev,
@@ -21,15 +22,19 @@
                liblua5.3-dev,
                lua5.3,
                python3,
-               python3-psycopg2
-Standards-Version: 4.5.1
+               python3-psycopg2,
+               python3-pyosmium
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
 Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git
 Homepage: https://osm2pgsql.org/
 
 Package: osm2pgsql
 Architecture: any
-Depends: ${shlibs:Depends},
+Depends: python3-psycopg2,
+         python3-pyosmium,
+         ${python3:Depends},
+         ${shlibs:Depends},
          ${misc:Depends}
 Recommends: postgis
 Description: OpenStreetMap data to PostgreSQL converter

## osm2pgsql 1.6.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,20 @@
-set(PACKAGE osm2pgsql)
-set(PACKAGE_NAME osm2pgsql)
-set(PACKAGE_VERSION 1.4.1)
-
-cmake_minimum_required(VERSION 2.8.12)
-
-project(osm2pgsql)
+
+cmake_minimum_required(VERSION 3.5.0)
+
+project(osm2pgsql VERSION 1.6.0 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+
+# Do not create install targets when run as a subproject.
+# Currently used by Nominatim which cannot yet rely on installed versions
+# of osm2pgsql.
+if (${PROJECT_NAME} STREQUAL ${CMAKE_PROJECT_NAME})
+    set(ENABLE_INSTALL ON)
+else()
+    set(ENABLE_INSTALL OFF)
+endif()
 
 if (WIN32)
     set(DEFAULT_STYLE "default.style" CACHE STRING "Default style used unless one is given on the command line")
@@ -25,32 +31,31 @@
     message(FATAL_ERROR "In-source builds are not allowed, please use a separate build directory like `mkdir build && cd build && cmake ..`")
 endif()
 
-message(STATUS "Building osm2pgsql ${PACKAGE_VERSION}")
+message(STATUS "Building osm2pgsql ${PROJECT_VERSION}")
 
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE RelWithDebInfo)
 endif()
 
 if (NOT "${CMAKE_CXX_STANDARD}")
-    set(CMAKE_CXX_STANDARD 11)
+    set(CMAKE_CXX_STANDARD 14)
 endif()
 message(STATUS "Building in C++${CMAKE_CXX_STANDARD} mode")
 set(CMAKE_CXX_EXTENSIONS OFF)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 if (MSVC)
-    add_definitions(-D_CRT_SECURE_NO_WARNINGS -DNOMINMAX -wd4996)
+    add_definitions(-D_CRT_SECURE_NO_WARNINGS -DNOMINMAX)
+    add_compile_options(-wd4996)
     set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /ignore:4099 /STACK:30000000")
 else()
-    add_definitions(-Wall)
-    if (CMAKE_VERSION VERSION_LESS 3.1)
-        add_definitions(-std=c++11)
-    endif()
+    add_compile_options(-Wall)
 endif()
 
 option(EXTERNAL_LIBOSMIUM "Do not use the bundled libosmium" OFF)
 option(EXTERNAL_PROTOZERO "Do not use the bundled protozero" OFF)
 option(EXTERNAL_FMT       "Do not use the bundled fmt"       OFF)
+option(EXTERNAL_RAPIDJSON "Do not use the bundled rapidjson" OFF)
 
 set(USE_PROJ_LIB "auto" CACHE STRING "Which version of PROJ API to use: ('4', '6', 'off', or 'auto')")
 
@@ -61,10 +66,10 @@
     set(PostgreSQL_TYPE_INCLUDE_DIR /usr/include)
 endif()
 
-set(MINIMUM_POSTGRESQL_SERVER_VERSION "9.3")
-set(MINIMUM_POSTGRESQL_SERVER_VERSION_NUM "90300")
-
-set(PostgreSQL_ADDITIONAL_VERSIONS "13" "12" "11" "10" "9.6" "9.5" "9.4" "9.3")
+set(MINIMUM_POSTGRESQL_SERVER_VERSION "9.5")
+set(MINIMUM_POSTGRESQL_SERVER_VERSION_NUM "90500")
+
+set(PostgreSQL_ADDITIONAL_VERSIONS "14" "13" "12" "11" "10" "9.6" "9.5")
 
 #############################################################
 # Version
@@ -74,7 +79,7 @@
 
 if (GIT_FOUND)
     execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tags --dirty=-changed
-                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
+                    WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
                     OUTPUT_VARIABLE VERSION_FROM_GIT
                     ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
     if (VERSION_FROM_GIT)
@@ -122,7 +127,7 @@
             message(STATUS "  found")
         endif()
 
-        add_definitions(-g -O0 -fno-inline-functions -fno-inline --coverage)
+        add_compile_options(-g -O0 -fno-inline-functions -fno-inline --coverage)
 
         set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage"
             CACHE
@@ -174,10 +179,14 @@
     set(FMT_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/fmt/include")
 endif()
 
+if (NOT EXTERNAL_RAPIDJSON)
+    set(RAPIDJSON_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/contrib/rapidjson/include")
+endif()
+
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR})
 
-find_package(Osmium 2.15.6 REQUIRED COMPONENTS io)
-include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS} ${PROTOZERO_INCLUDE_DIR} ${FMT_INCLUDE_DIR})
+find_package(Osmium 2.17.3 REQUIRED COMPONENTS io)
+include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS} ${PROTOZERO_INCLUDE_DIR} ${FMT_INCLUDE_DIR} ${RAPIDJSON_INCLUDE_DIR})
 
 if (WITH_LUA)
     if (WITH_LUAJIT)
@@ -283,7 +292,7 @@
 
 message(STATUS "Looking for clang-tidy")
 find_program(CLANG_TIDY
-             NAMES clang-tidy clang-tidy-10 clang-tidy-9 clang-tidy-8 clang-tidy-7)
+             NAMES clang-tidy clang-tidy-14 clang-tidy-13 clang-tidy-12 clang-tidy-11)
 
 if (CLANG_TIDY)
     message(STATUS "Looking for clang-tidy - found ${CLANG_TIDY}")
@@ -324,5 +333,9 @@
 # Install
 #############################################################
 
-install(TARGETS osm2pgsql DESTINATION bin)
-install(FILES default.style empty.style DESTINATION share/osm2pgsql)
+if (ENABLE_INSTALL)
+    install(TARGETS osm2pgsql DESTINATION bin)
+    install(PROGRAMS scripts/osm2pgsql-replication DESTINATION bin)
+    install(FILES docs/osm2pgsql-replication.1 DESTINATION share/man/man1)
+    install(FILES default.style empty.style DESTINATION share/osm2pgsql)
+endif()

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
         -s
         -t man
         --template ${CMAKE_CURRENT_SOURCE_DIR}/manpage.template
-        --variable "version=${PACKAGE_VERSION}"
+        --variable "version=${PROJECT_VERSION}"
         --variable "title=OSM2PGSQL"
         --variable "section=1"
     )
@@ -27,5 +27,6 @@
     message(STATUS "  Manual page can not be built")
 endif()
 
-install(FILES osm2pgsql.1 DESTINATION share/man/man1)
-
+if (ENABLE_INSTALL)
+    install(FILES osm2pgsql.1 DESTINATION share/man/man1)
+endif()

=== src/CMakeLists.txt ===

add_library(osm2pgsql_lib STATIC)

target_sources(osm2pgsql_lib PRIVATE
  db-check.cpp
  db-copy.cpp
  dependency-manager.cpp
  expire-tiles.cpp
  gazetteer-style.cpp
  geom.cpp
  input.cpp
  logging.cpp
  middle.cpp
  middle-pgsql.cpp
  middle-ram.cpp
  node-locations.cpp
  node-persistent-cache.cpp
  options.cpp
  ordered-index.cpp
  osmdata.cpp
  osmium-builder.cpp
  output-gazetteer.cpp
  output-null.cpp
  output-pgsql.cpp
  output.cpp
  pgsql.cpp
  pgsql-helper.cpp
  progress-display.cpp
  reprojection.cpp
  table.cpp
  taginfo.cpp
  tagtransform-c.cpp
  tagtransform.cpp
  thread-pool.cpp
  util.cpp
  wildcmp.cpp
)

if (LUA_FOUND OR LUAJIT_FOUND)
    set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
                 "${CMAKE_CURRENT_SOURCE_DIR}/init.lua")
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/init.lua" LUA_INIT_CODE)
    configure_file(lua-init.cpp.in lua-init.cpp @ONLY)
    target_sources(osm2pgsql_lib PRIVATE
        flex-table.cpp
        flex-table-column.cpp
        geom-transform.cpp
        lua-utils.cpp
        output-flex.cpp
        tagtransform-lua.cpp
        ${CMAKE_CURRENT_BINARY_DIR}/lua-init.cpp)
endif()

target_sources(osm2pgsql_lib PRIVATE ${PROJECT_BINARY_DIR}/src/version.cpp)

if (HAVE_PROJ4)
    target_sources(osm2pgsql_lib PRIVATE reprojection-generic-proj4.cpp)
    if (NOT MSVC)
        set_source_files_properties(reprojection-generic-proj4.cpp
            PROPERTIES COMPILE_FLAGS -Wno-deprecated-declarations)
    endif()
elseif(HAVE_PROJ6)
    target_sources(osm2pgsql_lib PRIVATE reprojection-generic-proj6.cpp)
else()
    target_sources(osm2pgsql_lib PRIVATE reprojection-generic-none.cpp)
endif()

set_target_properties(osm2pgsql_lib PROPERTIES OUTPUT_NAME osm2pgsql)
target_link_libraries(osm2pgsql_lib ${LIBS})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -45,26 +45,24 @@
 set_test(test-expire-tiles LABELS NoDB)
 set_test(test-geom LABELS NoDB)
 set_test(test-middle)
+set_test(test-node-locations LABELS NoDB)
 set_test(test-options-database LABELS NoDB)
 set_test(test-options-parse LABELS NoDB)
 set_test(test-options-projection)
+set_test(test-ordered-index LABELS NoDB)
 set_test(test-output-gazetteer)
-set_test(test-output-multi-line)
-set_test(test-output-multi-point)
-set_test(test-output-multi-point-multi-table)
-set_test(test-output-multi-polygon)
 set_test(test-output-pgsql)
 set_test(test-output-pgsql-area)
 set_test(test-output-pgsql-hstore-match-only)
 set_test(test-output-pgsql-int4)
 set_test(test-output-pgsql-schema)
+set_test(test-output-pgsql-style-file)
 set_test(test-output-pgsql-tablespace LABELS Tablespace)
 set_test(test-output-pgsql-validgeom)
 set_test(test-output-pgsql-z_order)
 set_test(test-parse-osmium LABELS NoDB)
 set_test(test-persistent-cache LABELS NoDB)
 set_test(test-pgsql)
-set_test(test-ram-cache LABELS NoDB)
 set_test(test-reprojection LABELS NoDB)
 set_test(test-taginfo LABELS NoDB)
 set_test(test-util LABELS NoDB)
@@ -72,13 +70,11 @@
 
 # these tests require LUA support
 if (HAVE_LUA)
-    set_test(test-output-multi-line-storage)
-    set_test(test-output-multi-poly-trivial)
-    set_test(test-output-multi-tags)
     set_test(test-output-flex)
     set_test(test-output-flex-area)
     set_test(test-output-flex-attr)
     set_test(test-output-flex-bbox)
+    set_test(test-output-flex-cluster)
     set_test(test-output-flex-invalid-geom)
     set_test(test-output-flex-line)
     set_test(test-output-flex-lua-fail)
@@ -103,8 +99,8 @@
     set_test(test-output-flex-way-relation-del)
 
     set_test(test-output-flex-example-configs)
-    set(FLEX_EXAMPLE_CONFIGS "compatible,data-types,generic,geometries,route-relations,simple,unitable")
-    # places.lua not tested because it needs dkjson package
+    set(FLEX_EXAMPLE_CONFIGS "attributes,compatible,data-types,generic,geometries,places,route-relations,simple,unitable")
+    # with-schema.lua is not tested because it needs the schema created in the database
     set_tests_properties(test-output-flex-example-configs PROPERTIES ENVIRONMENT "EXAMPLE_FILES=${FLEX_EXAMPLE_CONFIGS}")
 endif()
 
@@ -135,6 +131,7 @@
     set_tests_properties(regression-test-pbf PROPERTIES TIMEOUT ${TESTING_TIMEOUT})
     set_tests_properties(regression-test-pbf
                          PROPERTIES FIXTURES_REQUIRED Tablespace)
+    set_tests_properties(regression-test-pbf PROPERTIES ENVIRONMENT OSM2PGSQL_BINARY=$<TARGET_FILE:osm2pgsql>)
     message(STATUS "Added test: regression-test-pbf (needs Python with psycopg2 module)")
 else()
     message(WARNING "Can not find python, regression test disabled")

=== debian/changelog ===
osm2pgsql (1.6.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Require at least libosmium2-dev 2.17.3.
  * Update copyright file.
  * Add python3 dependencies for osm2pgsql-replication.
  * Add patch to fix manpage issues.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 24 Jan 2022 19:20:23 +0100

osm2pgsql (1.5.2+ds-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.0, no changes.
  * Bump debhelper compat to 12, changes:
    - Drop --list-missing from dh_install
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 12 Jan 2022 07:41:58 +0100

## osm2pgsql 1.7.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 
 cmake_minimum_required(VERSION 3.5.0)
 
-project(osm2pgsql VERSION 1.6.0 LANGUAGES CXX C)
+project(osm2pgsql VERSION 1.7.0 LANGUAGES CXX C)
 
 set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
 
@@ -38,7 +38,7 @@
 endif()
 
 if (NOT "${CMAKE_CXX_STANDARD}")
-    set(CMAKE_CXX_STANDARD 14)
+    set(CMAKE_CXX_STANDARD 17)
 endif()
 message(STATUS "Building in C++${CMAKE_CXX_STANDARD} mode")
 set(CMAKE_CXX_EXTENSIONS OFF)
@@ -160,9 +160,6 @@
 
 add_definitions(-DDEFAULT_STYLE=\"${DEFAULT_STYLE}\")
 
-CHECK_INCLUDE_FILES(termios.h HAVE_TERMIOS_H)
-CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
-
 #############################################################
 # Find necessary libraries
 #############################################################
@@ -190,15 +187,19 @@
 
 if (WITH_LUA)
     if (WITH_LUAJIT)
+        message(STATUS "Building with LuaJIT support")
         find_package(LuaJIT REQUIRED)
         include_directories(SYSTEM ${LUAJIT_INCLUDE_DIR})
-        set(HAVE_LUAJIT 1)
+        add_definitions(-DHAVE_LUAJIT=1)
     else()
+        message(STATUS "Building with Lua support")
         find_package(Lua REQUIRED)
         include_directories(SYSTEM ${LUA_INCLUDE_DIR})
     endif()
-    set(HAVE_LUA 1)
-    find_program(LUA_EXE lua)
+    add_definitions(-DHAVE_LUA=1)
+    find_program(LUA_EXE NAMES lua lua5.4 lua5.3 lua5.2 lua5.1)
+else()
+    message(STATUS "Building without Lua support")
 endif()
 
 find_package(Boost 1.50 REQUIRED COMPONENTS system filesystem)
@@ -221,7 +222,7 @@
         message(STATUS "Found proj_api.h")
         find_library(PROJ_LIBRARY NAMES proj)
         message(STATUS "Found Proj [API 4] ${PROJ_LIBRARY}")
-        set(HAVE_GENERIC_PROJ 1)
+        add_definitions(-DHAVE_GENERIC_PROJ=4)
         set(HAVE_PROJ4 1)
         list(APPEND LIBS ${PROJ_LIBRARY})
         include_directories(SYSTEM ${PROJ4_INCLUDE_DIR})
@@ -230,7 +231,7 @@
         find_library(PROJ_LIBRARY NAMES proj)
         if (PROJ_LIBRARY)
             message(STATUS "Found Proj [API 6] ${PROJ_LIBRARY}")
-            set(HAVE_GENERIC_PROJ 1)
+            add_definitions(-DHAVE_GENERIC_PROJ=6)
             set(HAVE_PROJ6 1)
             list(APPEND LIBS ${PROJ_LIBRARY})
             include_directories(SYSTEM ${PROJ6_INCLUDE_DIR})
@@ -275,12 +276,6 @@
 # Build the library and executable file
 #############################################################
 
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
-
-if (NOT HAVE_UNISTD_H AND NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/unistd.h)
-   file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/unistd.h "// empty header\n")
-endif()
-
 add_subdirectory(src)
 
 add_executable(osm2pgsql src/osm2pgsql.cpp)
@@ -319,6 +314,10 @@
         set(TESTING_TIMEOUT 1200)
     endif()
     add_subdirectory(tests)
+    configure_file(
+        ${PROJECT_SOURCE_DIR}/tests/run-behave.in
+        ${PROJECT_BINARY_DIR}/run-behave
+    )
 else()
     message(STATUS "Tests disabled. Set BUILD_TESTS=ON to enable tests.")
 endif()
@@ -336,6 +335,5 @@
 if (ENABLE_INSTALL)
     install(TARGETS osm2pgsql DESTINATION bin)
     install(PROGRAMS scripts/osm2pgsql-replication DESTINATION bin)
-    install(FILES docs/osm2pgsql-replication.1 DESTINATION share/man/man1)
     install(FILES default.style empty.style DESTINATION share/osm2pgsql)
 endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,9 @@
   expire-tiles.cpp
   gazetteer-style.cpp
   geom.cpp
+  geom-box.cpp
+  geom-from-osm.cpp
+  geom-functions.cpp
   input.cpp
   logging.cpp
   middle.cpp
@@ -18,7 +21,6 @@
   options.cpp
   ordered-index.cpp
   osmdata.cpp
-  osmium-builder.cpp
   output-gazetteer.cpp
   output-null.cpp
   output-pgsql.cpp
@@ -31,12 +33,14 @@
   taginfo.cpp
   tagtransform-c.cpp
   tagtransform.cpp
+  tile.cpp
   thread-pool.cpp
   util.cpp
   wildcmp.cpp
+  wkb.cpp
 )
 
-if (LUA_FOUND OR LUAJIT_FOUND)
+if (WITH_LUA)
     set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
                  "${CMAKE_CURRENT_SOURCE_DIR}/init.lua")
     file(READ "${CMAKE_CURRENT_SOURCE_DIR}/init.lua" LUA_INIT_CODE)
@@ -44,6 +48,7 @@
     target_sources(osm2pgsql_lib PRIVATE
         flex-table.cpp
         flex-table-column.cpp
+        flex-lua-geom.cpp
         geom-transform.cpp
         lua-utils.cpp
         output-flex.cpp

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -11,8 +11,7 @@
     target_link_libraries(${test_name} osm2pgsql_lib catch_main_lib)
     add_test(NAME ${test_name} COMMAND ${test_name})
 
-    set_tests_properties(${test_name} PROPERTIES TIMEOUT ${TESTING_TIMEOUT}
-                                                 ENVIRONMENT SRCPATH=${CMAKE_CURRENT_SOURCE_DIR})
+    set_tests_properties(${test_name} PROPERTIES TIMEOUT ${TESTING_TIMEOUT})
 
     if (DEFINED test_param_LABELS)
         list(FIND test_param_LABELS Tablespace test_num_labels)
@@ -43,7 +42,16 @@
 set_test(test-db-copy-mgr)
 set_test(test-domain-matcher LABELS NoDB)
 set_test(test-expire-tiles LABELS NoDB)
-set_test(test-geom LABELS NoDB)
+set_test(test-geom-box LABELS NoDB)
+set_test(test-geom-collections LABELS NoDB)
+set_test(test-geom-linestrings LABELS NoDB)
+set_test(test-geom-multilinestrings LABELS NoDB)
+set_test(test-geom-multipoints LABELS NoDB)
+set_test(test-geom-multipolygons LABELS NoDB)
+set_test(test-geom-null LABELS NoDB)
+set_test(test-geom-points LABELS NoDB)
+set_test(test-geom-polygons LABELS NoDB)
+set_test(test-geom-transform LABELS NoDB)
 set_test(test-middle)
 set_test(test-node-locations LABELS NoDB)
 set_test(test-options-database LABELS NoDB)
@@ -65,26 +73,18 @@
 set_test(test-pgsql)
 set_test(test-reprojection LABELS NoDB)
 set_test(test-taginfo LABELS NoDB)
+set_test(test-tile LABELS NoDB)
 set_test(test-util LABELS NoDB)
 set_test(test-wildcard-match LABELS NoDB)
+set_test(test-wkb LABELS NoDB)
 
 # these tests require LUA support
-if (HAVE_LUA)
+if (WITH_LUA)
     set_test(test-output-flex)
-    set_test(test-output-flex-area)
-    set_test(test-output-flex-attr)
-    set_test(test-output-flex-bbox)
-    set_test(test-output-flex-cluster)
-    set_test(test-output-flex-invalid-geom)
-    set_test(test-output-flex-line)
-    set_test(test-output-flex-lua-fail)
-    set_test(test-output-flex-multigeom)
     set_test(test-output-flex-multi-input)
     set_test(test-output-flex-nodes)
-    set_test(test-output-flex-nogeom)
     set_test(test-output-flex-uni)
     set_test(test-output-flex-relations)
-    set_test(test-output-flex-relation-changes)
     set_test(test-output-flex-relation-combinations)
     set_test(test-output-flex-schema)
     set_test(test-output-flex-stage2)
@@ -99,7 +99,7 @@
     set_test(test-output-flex-way-relation-del)
 
     set_test(test-output-flex-example-configs)
-    set(FLEX_EXAMPLE_CONFIGS "attributes,compatible,data-types,generic,geometries,places,route-relations,simple,unitable")
+    set(FLEX_EXAMPLE_CONFIGS "attributes,bbox,compatible,data-types,generic,geometries,places,route-relations,simple,unitable")
     # with-schema.lua is not tested because it needs the schema created in the database
     set_tests_properties(test-output-flex-example-configs PROPERTIES ENVIRONMENT "EXAMPLE_FILES=${FLEX_EXAMPLE_CONFIGS}")
 endif()
@@ -120,24 +120,23 @@
 endif()
 
 
-find_package(PythonInterp 3)
+find_program(BEHAVE_BIN NAMES behave)
 
-if (PYTHONINTERP_FOUND)
-    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/regression-test.py.in
-                   ${CMAKE_CURRENT_BINARY_DIR}/regression-test.py)
+if (BEHAVE_BIN)
+    foreach(BDD_TEST IN ITEMS command-line flex regression)
+        add_test(NAME bdd-${BDD_TEST}
+                 COMMAND behave -DBINARY=$<TARGET_FILE:osm2pgsql> ${BDD_TEST}
+                 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bdd)
+        message(STATUS "Added test: bdd-${BDD_TEST}")
+    endforeach(BDD_TEST)
 
-    add_test(NAME regression-test-pbf
-             COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/regression-test.py -v)
-    set_tests_properties(regression-test-pbf PROPERTIES TIMEOUT ${TESTING_TIMEOUT})
-    set_tests_properties(regression-test-pbf
+    set_tests_properties(bdd-regression
                          PROPERTIES FIXTURES_REQUIRED Tablespace)
-    set_tests_properties(regression-test-pbf PROPERTIES ENVIRONMENT OSM2PGSQL_BINARY=$<TARGET_FILE:osm2pgsql>)
-    message(STATUS "Added test: regression-test-pbf (needs Python with psycopg2 module)")
 else()
-    message(WARNING "Can not find python, regression test disabled")
+    message(WARNING "Cannot find behave, BDD tests disabled")
 endif()
 
-if (HAVE_LUA)
+if (WITH_LUA)
     if (LUA_EXE)
         message(STATUS "Added test: lua-lib")
         add_test(NAME lua-lib COMMAND ${LUA_EXE} lua/tests.lua

=== debian/changelog ===
osm2pgsql (1.7.0+ds-1) unstable; urgency=medium

  * New upstream release.
  * Replace manpage.patch with upstream changes.
  * Bump Standards-Version to 4.6.1, no changes.
  * Drop pr1641-osm2pgsql-replication-manpage.patch, included upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 15 Aug 2022 16:10:50 +0200

=== debian/control ===
--- 
+++ 
@@ -22,9 +22,10 @@
                liblua5.3-dev,
                lua5.3,
                python3,
+               python3-argparse-manpage,
                python3-psycopg2,
                python3-pyosmium
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/osm2pgsql
 Vcs-Git: https://salsa.debian.org/debian-gis-team/osm2pgsql.git
 Homepage: https://osm2pgsql.org/
